hdu3535 AreYouBusy

Problem Description

Happy New Term!

As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad.

What‘s more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define
the things that she can choose as "jobs". A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be
a good junior(which means that she should follow the boss‘s advice)?

Input

There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there
are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means
the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.

Output

One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .

Sample Input

3 3
2 1
2 5
3 8
2 0
1 0
2 1
3 2
4 3
2 1
1 1

3 4
2 1
2 5
3 8
2 0
1 1
2 8
3 2
4 4
2 1
1 1

1 1
1 0
2 1

5 3
2 0
1 0
2 1
2 0
2 2
1 1
2 0
3 2
2 1
2 1
1 5
2 8
3 2
3 8
4 9
5 10

Sample Output

5
13
-1
-1

这道题用的知识比較多,是把三个类型结合起来。让我受益非常多。

首先用二维状态dp[i][j]表示前i组花费j元获得最多的价值,有三个状态方程,一个是至少一个,一个是至多一个。还有是任意,那么分情况讨论即可了。

这里要说一下的是对二维背包,第二和第三种情况都要先把上一行的值继承到这一行来。然后再dp,dp过程中。是对这一行值背包,还是对上一行的值背包。这点要考虑清楚。具体的在代码里了。

#include<stdio.h>
#include<string.h>
int max(int a,int b){
	return a>b?a:b;
}
struct node{
	int w,v;
}a[106][106];
int dp[106][106],n1[106],m1[106];
int main()
{
	int n,m,i,j,k;
	while(scanf("%d%d",&n,&m)!=EOF)
	{
		for(i=1;i<=n;i++){
			scanf("%d%d",&n1[i],&m1[i]);
			for(j=1;j<=n1[i];j++){
				scanf("%d%d",&a[i][j].w,&a[i][j].v);
			}
		}
		memset(dp,-1,sizeof(dp));
		for(i=0;i<=m;i++){
			dp[0][i]=0;
		}
		for(i=1;i<=n;i++){
			if(m1[i]==2){//随便放
				for(j=m;j>=0;j--){//先把上一行的值都储存下来
					dp[i][j]=dp[i-1][j];
				}
				for(k=1;k<=n1[i];k++){
					for(j=m;j>=a[i][k].w;j--){
						//if(dp[i-1][j-a[i][k].w]!=-1)
						//dp[i][j]=max(dp[i][j],dp[i-1][j-a[i][k].w]+a[i][k].v);注意这里不能这么写。由于这里是对i这组内背包,在i组上能够叠加
						if(dp[i][j-a[i][k].w]!=-1)
						dp[i][j]=max(dp[i][j],dp[i][j-a[i][k].w]+a[i][k].v);
					}
				}
			}
			else if(m1[i]==1){//最多放一个
				for(j=m;j>=0;j--){//和上面一样,先等于上一行的值
					dp[i][j]=dp[i-1][j];
				}
				for(j=m;j>=0;j--){
					for(k=1;k<=n1[i];k++){
						if(j>=a[i][k].w && dp[i-1][j-a[i][k].w]!=-1){//这里注意是对i-1这组背包。以为假设 dp[i-1][j-a[i][k].w]==-1。那么转移过来的状态就已经错了,这个状态的值肯定错了,并且这一组仅仅能放一个,不能在组内叠加。

dp[i][j]=max(dp[i][j],dp[i-1][j-a[i][k].w]+a[i][k].v);//这一行不能写成dp[i][j-a[i][k].w]+a[i][k].v,由于假设出现多个w[k]==0的情况。那么dp[i][j]就会一直改变,那么一定会取多个而不是最多取一个
						}
					}
				}
			}
			else if(m1[i]==0){//至少放一个,这一组不能继承上一行的,以为上一行不为-1的,这一行不一定不为-1。由于这组要放一个以上才成立。和本行有关
				for(k=1;k<=n1[i];k++){
					for(j=m;j>=a[i][k].w;j--){
						if(dp[i][j-a[i][k].w]!=-1){//这里由两个方程转移过来
							dp[i][j]=max(dp[i][j],dp[i][j-a[i][k].w]+a[i][k].v);
						}
						if(dp[i-1][j-a[i][k].w]!=-1){
							dp[i][j]=max(dp[i][j],dp[i-1][j-a[i][k].w]+a[i][k].v);
						}
					}
				}
			}
		}
		printf("%d\n",dp[n][m]);
	}
	return 0;
}

时间: 2025-01-21 20:37:06

hdu3535 AreYouBusy的相关文章

hdu3535(AreYouBusy)

题目链接:传送门 题目大意:有 n 组任务,m 个体力,每组任务有 k 个,分类为 f,每个任务花费 x 体力,得到 y 开心值,求最大开心值,若不能完成输出-1 分类为 0:这一组中的 k 个任务至少选择一个. 分类为 1:这一组中的 k 个任务最多选择一个. 分类为 2:这一组中的 k 个任务随便选择. 分析: 1.对于分类 0,若当前判断到一个任务 x,则有两种情况: (1)它是该组第一个被选择的任务,则它更新的状态只能是将上一层的状态转移更新到当前位置. (2)它不是第一个被选择的任务,

HDU 3535 AreYouBusy(组合背包)

传送门 AreYouBusy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 4362    Accepted Submission(s): 1761 Description Happy New Term!As having become a junior, xiaoA recognizes that there is not much

UESTC 424 AreYouBusy

混合三种背包问题. 定义:dp[i][k]表示体积为k的时候,在前i堆里拿到的最大价值. 第一类,至少选一项,dp初值全赋为负无穷,这样才能保证不会出现都不选的情况.dp[i][k] = max(dp[i][k],max(dp[i-1][k-c]+g,dp[i][k-c]))其中: dp[i][k]是不选当前项dp[i-1][k-c]+g是表示第一次选这组的物品dp[i][k-c]+g表示选择当前物品,并且不是第一次选. 第二类最多选一个,一旦选则是第一次选dp[i][k] = max(dp[i

HDU 3535 AreYouBusy (混合背包)

题意:给你n组物品和自己有的价值s,每组有l个物品和有一种类型: 0:此组中最少选择一个 1:此组中最多选择一个 2:此组随便选 每种物品有两个值:是需要价值ci,可获得乐趣gi 问在满足条件的情况下,可以得到的最大的乐趣是多少,如果不能满足条件就输出-1 题解:二维01背包 dp[i][j]:前i组物品我们拥有j的价值时最大可获得的乐趣 0:我们需要先把dp[i]所有赋值为负无穷,这样就只能最少选一个才能改变负无穷 1:我们不需要:dp[i][j-ci]+gi(在此组中再选一个),这样就一定最

HDU 3535 AreYouBusy

分组背包 最多取一个的组,则对于该组来说,每一个状态只可能由前一组的状态过来,分不取和取两种 至少取一个,则没了不取的选择,即没有dp[i][j]=dp[i-1][j]的递推式 任意取,即01背包,取法包括由前一组不取或取一个,或由该组取一个 dp[i][j]表示前i组,消耗j时间所能取得的最大值 初值赋为-1,表示该状态不可达,对于dp[0],初值赋为0,即什么都没有的时候最大的快乐值为0 还有一个要注意的点c[k]可能为0,会影响到递推式的顺序 发现做这种混合背包的题非常有助于弄清楚各种背包

hdu3535 背包大杂汇

题目链接:http://acm.split.hdu.edu.cn/showproblem.php?pid=3535 //不想写题解,这道题让我对背包的理解更深了,我相信我不会忘记的.... 代码: #include<iostream> #include<cstdio> #include<algorithm> #include<cstring> #include<cmath> using namespace std; const int INF=0

[HDU 3535] AreYouBusy (动态规划 混合背包)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3535 题意:有n个任务集合,需要在T个时间单位内完成.每个任务集合有属性,属性为0的代表至少要完成1个,属性为1的为至多完成1个,属性为2的为任意完成. 每个任务做完后都有个价值,问在T个时间单位内完成n个任务集合的任务获得的最大价值是多少?如果不能满足要求输出-1 首先先分析什么情况下输出-1: 因为属性为0的代表至少要完成1个,当遇到一个属性为0的任务集合里一个都无法完成的时候,输出-1. 其他

【dp】 AreYouBusy

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3535 题意: 多组背包, 0类型为为至少去1样, 1为至多取1样, 2 为随意. 如果将2类型 再添加一组数据 (0, 0), 则可转换为0类型, 即0,1 背包问题, 1类型为经典分组背包. /***Good Luck***/ #define _CRT_SECURE_NO_WARNINGS #include <iostream> #include <cstdio> #include

hdu 3535 AreYouBusy 混合背包

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3535 题意:有三种任务,至少完成一个,至多完成一个,任意完成.现在给出k组任务,每组任务都属于三种任务的一种.每个任务都会消耗时间,获得幸福感.求时间T内的最大满足感. 三种背包的混合.还是考察对背包问题的理解.显然一维已经满足不了要求了,我们设d[k][j]代表第k组容量为j时获得的最大满足感. 可以明显比较出三种背包的区别.(任意取也就是01背包) 任意取,至少取一种的区别:只取一种的状态是否非